@echo off
setlocal enabledelayedexpansion
cd /d "%~dp0"
if exist "%PROGRAMFILES(X86)%" (set arch=64) else (set arch=32)

call config.bat
set "cmdsuffix= "
if "%debug%" == "0" set "cmdsuffix=>nul 2>&1"
call "tools\kill.bat"

echo * Downloading components
mkdir downloads >nul 2>&1
for %%m in (%mods%) do (
	echo %%m ...
	call "mods\%%m.bat" download %cmdsuffix%
	if "!errorlevel!" neq "0" goto error
)
if "%~1" == "-download" goto exit

echo.
echo * Installing components
mkdir components >nul 2>&1
for %%m in (%mods%) do (
	echo %%m ...
	setlocal
	call "mods\%%m.bat" install %cmdsuffix%
	endlocal
	if "!errorlevel!" neq "0" goto error
)
goto exit

:error
echo.
echo Failed^^!
if not "%~1" == "-nopause" if not "%~1" == "-download" pause
exit /b 1

:exit
echo.
echo Success^^!
if not "%~1" == "-download" echo Log out and back in to apply
if not "%~1" == "-nopause" if not "%~1" == "-download" pause
exit /b 0